<?php


namespace Repository;


use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;
use Util\Utilities;
use Util\InstanceProvider;

class ZmartOperator
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * ZmartOperator constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findOperators($organizationId, $nrorgoper)
    {
        $filterNroegoper = "WHERE OPER.NRORG = $organizationId";
        if($nrorgoper && $nrorgoper != 20 && $organizationId != $nrorgoper){
            $filterNroegoper = <<<SQL
                        LEFT JOIN ORGRELACOPER ORP ON ORP.CDOPERADOR = OPER.CDOPERADOR
                        WHERE ORP.NRORGOPER = $nrorgoper
SQL;
        }
        $query = <<<SQL
            SELECT *
              FROM (SELECT PARC.NRINSCRICAOPARC, PARC.NMPRINCIPALPARC AS NMPARCNEGOCIO, OPER.NMACESSO, OPER.CDOPERADOR,
                           OPER.CDPAIS, OPER.NMOPERADOR, OPER.DTULTATUOPER, OPER.CDCLIENTE, OPER.CDEMPRESA, OPER.DSEMAILOPER, OPER.IDOPERMASTER,
                           OPER.IDOPERACESSO, OPER.IDOPERATIVO, OPER.NRORG, OPER.DTINCLUSAO, OPER.DTULTATU,
                           OPER.NRORGINCLUSAO, OPER.CDOPERINCLUSAO, OPER.CDOPERULTATU, OPER.NRORGULTATU,
                           OPER.NRPARCNEGOCIO, OPER.NRORGSELECIONADA, OPER.CDFILIALSELECIONADA, OPER.NRPERFILSELECIONADO,
                           OPER.NRORGTRAB, OPER.NRESTRUTTRAB, OPER.IDATIVO, OPER.IDTPOPERADOR, ORG.NMORGANIZACAO, EST.NMESTRUTURAM,
                           CLI.NMRAZSOCCLIE, PA.NMPAIS, OPER.DTULTACESOPER, OPER.NRORGOPER
                      FROM OPERADOR OPER
                 LEFT JOIN ORGANIZACAO ORG ON ORG.NRORG = OPER.NRORG
                 LEFT JOIN ESTRUTURAM EST ON EST.NRORG = OPER.NRORG
                                         AND EST.NRESTRUTURAM = OPER.NRESTRUTTRAB
                 LEFT JOIN CLIENTE CLI ON CLI.NRORG = OPER.NRORG
                                      AND CLI.CDCLIENTE = OPER.CDCLIENTE
                 LEFT JOIN PAIS PA ON PA.CDPAIS = OPER.CDPAIS
                 LEFT JOIN PARCNEGOCIO PARC ON PARC.NRORG = OPER.NRORG
                                           AND PARC.NRPARCNEGOCIO = OPER.NRPARCNEGOCIO
                  $filterNroegoper
                  AND OPER.IDOPERATIVO = 'A'
                  )

SQL;
        $entityManager = InstanceProvider::getConnectionCustom()->updateVpdConnection($organizationId,true);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
        return $this->createAndExecuteQueryAndBuildResponseData($entityManager, $query);
    }
}