<?php

namespace Service\ChartView;

use Zeedhi\Framework\DependencyInjection\InstanceManager;
class ListCard extends ChartViewAbstract implements ChartViewInterface {

    const TYPE_ID_LIST_CARD = "58a5e65c3a34b43690ebda1d";

    public $widget;
    public $widgetData;

    function __construct($widget = null) {
        $this->widget = $widget;
        $this->widgetData = [];
    }

    public function getChildren(){
        $children = [];
        foreach($this->widgetData as $index=>$data){
            $xKey = $this->widget["fieldItemTitle"];
            $title = $data[$xKey];
            $children[] = [
                "name" => "CardList_".$title."_nameRow",
                "component" => "ZdRow",
                "children" => [
                    [
                        "name" => "CardList_".$title."_nameText",
                        "component" => "ZdText",
                        "text" => $title,
                        "tag" => "h3",
                        "cssClass" => $index>0 ? "zd-pt-4" : "",
                    ],
                ],
            ];
            $cards = [];
            foreach($this->widget["yKeys"] as $i=>$yKey){
                $cardTitle = $this->widget["customLabels"][$i];
                $value = !empty($data[$yKey]) ? $data[$yKey] : 0;
                $cards[] = [
                    "name" => "CardList_".$title."_card_".$yKey,
                    "component" => self::CARD_COMPONENT,
                    "widget" => $this->widget,
                    "cardDrillValue" => $title,
                    "cardValue" => $value,
                    "children" => [
                        [
                            "name" => "CardTitle_".$title."_card_".$yKey,
                            "component" => "TekCardTitle",
                            "title" => $cardTitle,
                            "events" => [
                                "onMounted" => "{{ChartViewController.replaceAnchorElement}}",
                            ],
                        ],
                        [
                            "name" => "CardValue_".$title."_card_".$yKey,
                            "component" => "ZdText",
                            "text" => "<div class='zd-display-flex zd-justify-center' style='height:100%;'><div class='zd-align-self-center'>".strval($value)."</div></div>",
                            "textResize" => [
                                "fontSize" => 12,
                                "min" => 12,
                                "max" => 100
                            ]
                        ]
                    ]
                ];
            }
            $children[] = [
                "name" => "CardList_".$title."_cardsRow",
                "component" => "ZdRow",
                "justify" => "space-around",
                "isCardsRow" => true,
                "children" => $cards,
            ];
        }
        return $children;
    }


    public function convertToNext():array {
        $this->fetchWidgetData();
        $widget = $this->widget;

        $indicatorNext = [
            "name" => "apexChart_" . $widget['id'],
            "id" => $widget['id'],
            "viewTypeId" => self::TYPE_ID_LIST_CARD,
            "isListCard" => true,
            "cssStyle" => "min-width: 700px;",
            "component" => "zdContainer",
            "children" => $this->getChildren(),
            "widget" => $widget,
        ];

        $this->widget = $indicatorNext;
        return $indicatorNext;
    }
}
