/* Sistemas Integrados TEKNISA
  Integrao - SAGA

 Nome: Trigger de atualizao da tabela CARACPRODSAGA

Criao:
09/04/2013 - Fabrcio Marcelo

@C:\web_560\sql\end_conv\oracle\01QK_GERTRGO_DTULTATU_CARACPRODSAGA.sql
*/


CREATE OR REPLACE TRIGGER DTULTATU_CARACPRODSAGA
BEFORE INSERT OR UPDATE OR DELETE
ON CARACPRODSAGA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCARACP := SYSDATE;
   END IF;

   IF UPDATING THEN
      IF (NVL(:OLD.CDPRODUTO     ,0) <> NVL(:NEW.CDPRODUTO     ,0)) OR
         (NVL(:OLD.VRPRAZMAXREC  ,0) <> NVL(:NEW.VRPRAZMAXREC  ,0)) OR
         (NVL(:OLD.VRPRAZMAXDEV  ,0) <> NVL(:NEW.VRPRAZMAXDEV  ,0)) OR
         (NVL(:OLD.VRPRAZVALIDADE,0) <> NVL(:NEW.VRPRAZVALIDADE,0)) OR
         (NVL(:OLD.VRPERMARMAZEM ,0) <> NVL(:NEW.VRPERMARMAZEM ,0)) OR
         (NVL(:OLD.CDGRUPREGARMAZ,0) <> NVL(:NEW.CDGRUPREGARMAZ,0)) OR
         (NVL(:OLD.VRTEMPMEDESTOQ,0) <> NVL(:NEW.VRTEMPMEDESTOQ,0)) OR
         (NVL(:OLD.VRTEMPMEDEXPED,0) <> NVL(:NEW.VRTEMPMEDEXPED,0)) OR
         (NVL(:OLD.VRTEMPMEDRECEB,0) <> NVL(:NEW.VRTEMPMEDRECEB,0)) OR
         (NVL(:OLD.VRSHELFLIFE   ,0) <> NVL(:NEW.VRSHELFLIFE   ,0)) OR
         (NVL(:OLD.VRJANELAFIFO  ,0) <> NVL(:NEW.VRJANELAFIFO  ,0)) OR
         (NVL(:OLD.VRJANFIFOTRANS,0) <> NVL(:NEW.VRJANFIFOTRANS,0)) OR
         (NVL(:OLD.CDMOTIVOBLOQ  ,0) <> NVL(:NEW.CDMOTIVOBLOQ  ,0)) OR
         (NVL(:OLD.VRLARGURA     ,0) <> NVL(:NEW.VRLARGURA     ,0)) OR
         (NVL(:OLD.VRALTURA      ,0) <> NVL(:NEW.VRALTURA      ,0)) OR
         (NVL(:OLD.VRPROFUNDIDADE,0) <> NVL(:NEW.VRPROFUNDIDADE,0)) OR
         (NVL(:OLD.VRPESO        ,0) <> NVL(:NEW.VRPESO        ,0)) OR
         (NVL(:OLD.VRPESOLIQ     ,0) <> NVL(:NEW.VRPESOLIQ     ,0)) OR
         (NVL(:OLD.VRVOLUME      ,0) <> NVL(:NEW.VRVOLUME      ,0)) OR
         (NVL(:OLD.VRPALPRODALT  ,0) <> NVL(:NEW.VRPALPRODALT  ,0)) OR
         (NVL(:OLD.VRPALPRODCOM  ,0) <> NVL(:NEW.VRPALPRODCOM  ,0)) OR
         (NVL(:OLD.VRFATORSKU    ,0) <> NVL(:NEW.VRFATORSKU    ,0)) OR
         (NVL(:OLD.VRPALPRODLAR  ,0) <> NVL(:NEW.VRPALPRODLAR  ,0)) THEN

         :NEW.DTULTATUCARACP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CARACPRODSAGA', '', 'CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CARACPRODSAGA MODIFY DTULTATUCARACP DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_CARACPRODSAGA','5.60.XXX'); END;
/

