CREATE OR REPLACE PROCEDURE BUSCA_CRITERIOS_CNC(P_ESTABELEC IN NUMBER,
                                                P_ADQUIRENTE IN NUMBER,
                                                P_VDNSU OUT VARCHAR,
                                                P_VDNSUPOS  OUT VARCHAR,
                                                P_VDTOLERANCIA OUT VARCHAR,
                                                P_VDNRAUT OUT VARCHAR,
                                                P_VDBANCO OUT VARCHAR,
                                                P_VDAGENCIA OUT VARCHAR,
                                                P_VDCCORRENTE OUT VARCHAR,
                                                P_VDPRODUTO OUT VARCHAR,
                                                P_VDADQUIRENTE OUT VARCHAR,
                                                P_VDBANDEIRA OUT VARCHAR,
                                                P_VDVRIGUAL OUT VARCHAR)
AS 
   V_COUNT NUMBER;
BEGIN
   BEGIN
      SELECT IDNSU, IDNSUPOS, IDTOLERANCIA, IDAUTORIZACAO, IDBANCO, IDAGENCIA, IDCONTCORR,
             IDPRODUTOADQ, IDADQUIRENTE, IDBANDEIRA, IDEXIGEVRIGUAL
        INTO P_VDNSU, P_VDNSUPOS, P_VDTOLERANCIA, P_VDNRAUT, P_VDBANCO, P_VDAGENCIA, P_VDCCORRENTE,
             P_VDPRODUTO, P_VDADQUIRENTE, P_VDBANDEIRA, P_VDVRIGUAL
        FROM VALIDACAOADQ
       WHERE NRADQUIRENTE = P_ADQUIRENTE;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         P_VDNSU  := NULL;
         P_VDNSUPOS  := NULL;
         P_VDTOLERANCIA := NULL;
         P_VDNRAUT := NULL;
         P_VDBANCO := NULL;
         P_VDAGENCIA := NULL;
         P_VDCCORRENTE := NULL;
         P_VDPRODUTO := NULL;
         P_VDADQUIRENTE := NULL;
         P_VDBANDEIRA := NULL;
         P_VDVRIGUAL := NULL;
   END;

   V_COUNT := 0;
   BEGIN
      SELECT COUNT(*)
        INTO V_COUNT
        FROM VALIDACAOADQEST
       WHERE NRADQUIRENTE = P_ADQUIRENTE
         AND NRESTABELEC = P_ESTABELEC;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_COUNT := 0;
   END;
   IF V_COUNT <> 0 THEN
      BEGIN
         SELECT IDNSU, IDNSUPOS, IDTOLERANCIA, IDAUTORIZACAO, IDBANCO, IDAGENCIA, IDCONTCORR,
                IDPRODUTOADQ, IDADQUIRENTE, IDBANDEIRA, IDEXIGEVRIGUAL
           INTO P_VDNSU, P_VDNSUPOS, P_VDTOLERANCIA, P_VDNRAUT, P_VDBANCO, P_VDAGENCIA, P_VDCCORRENTE,
                P_VDPRODUTO, P_VDADQUIRENTE, P_VDBANDEIRA, P_VDVRIGUAL
           FROM VALIDACAOADQEST
          WHERE NRADQUIRENTE = P_ADQUIRENTE
            AND NRESTABELEC = P_ESTABELEC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            P_VDNSU := NULL;
            P_VDNSUPOS := NULL;
            P_VDTOLERANCIA := NULL;
            P_VDNRAUT := NULL;
            P_VDBANCO := NULL;
            P_VDAGENCIA := NULL;
            P_VDCCORRENTE := NULL;
            P_VDPRODUTO := NULL;
            P_VDADQUIRENTE := NULL;
            P_VDBANDEIRA := NULL;
            P_VDVRIGUAL := NULL;
      END;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('BUSCA_CRITERIOS_CNC','6.10.000'); END;
/

