
/******************************************************************************/
/* Sistemas Integrados TEKNISA                                                */
/* Nome: 0013_CARSTPO_USR_IMPORTA_NF_COMPASSARGENTINA.sql                     */
/*                                                                            */
/* Descrio:                                                                 */
/* Procedure destinada a possibilitar que as NF's                             */
/* ajustadas/geradas pelo Portal sejam importadas                             */
/* no sistema da Teknisa e, para isso, a procedure verificar                 */
/* quatro tabelas intermedirias entre os dois sistemas (tabelas pertencentes */
/* ao banco de dados do sistema da Teknisa).                                  */
/* Criao:                                                                   */
/* 26/03/2012 - Marcelo Alexsandro                                            */
/******************************************************************************/


CREATE OR REPLACE PROCEDURE USR_IMPORTA_NF IS

--  26/03/2012 - Marcelo Alexsandro - UpDate 29/08/2013 --

   V_INPRXNOTAFISCAL  VARCHAR2(20);
   V_INPRXLANCTOESTOQ VARCHAR2(20);
   V_CDEMPRESA        VARCHAR2(2);
   V_IDATUESTTPOP     VARCHAR(1);
   V_PRXLANCTONF      VARCHAR2(10);
   V_PRXLANCESTQ      VARCHAR2(10);
   V_IDCTRLESTQ       PARAMFILIAL.IDCTRLESTQ%TYPE;
   V_DTPROCESSA       DATE;
   V_NRSEQITPROD      VARCHAR2(4);
   V_COUNTERRO        INTEGER;
   V_IDERRONFRELACAF  VARCHAR2(1);
   V_IDERRONFDUPLICA  VARCHAR2(1);
   V_CDMARCA          VARCHAR2(5);
   V_DSERROFACTURA    VARCHAR2(3000);
   V_DTENTRSAID       DATE;
   V_IDCONSORCFIN     PARAMGERAL.IDCONSORCFIN%TYPE;
   V_NRDIASBLOQNF     PARAMGERAL.NRDIASBLOQNF%TYPE;
   V_RETURN           VARCHAR2(1);
   V_ERROR            VARCHAR2(4000);
   V_COUNTSERIE       FLOAT;
--   V_ALIQUTMP         FLOAT;
   V_BASECALCIT       FLOAT;
   V_VRCONTIMPOIT     FLOAT;
   V_IMPOSINFO        FLOAT;
BEGIN
   V_RETURN := USR_FUNC_BLOQUEIO('USR_FACTURA_PORTAL%USR_ITEM_FACTURA%USR_ENCARGO_FACTURA%USR_AF_FACTURA', 'B');
   IF V_RETURN = 'S' THEN
      FOR C_NOTAFISCAL IN
       (SELECT
           N.CDFILIAL,
           N.NRSEQUENCIAL,
           F.CDFORNECED,
           F.NMFANTFORN,
           F.NMRAZSOCFORN,
           N.DTENTRSAID,
           N.NRNOTAFISC,
           N.CDSERIE,
           N.VRTOTALNF VRNOTAFISC,
           N.DTEMISSAO,
           N.VRIVAMP,
           N.VRIMPINT02,
           N.VRPIBBA,
           N.VRPERCIVA,
           N.VRABASTOS,
           N.VRPIBCP,
           N.VRPIBCBA,
           N.VRPIBSFE,
           N.VRPIBMZA,
           N.VRPIBSJ,
           N.VRPIBCAT,
           N.VRPIBTUC,
           N.VRPIBCTE,
           N.VRPIBSAL,
           N.VRPIBSL,
           N.VRPIBTF,
           N.VRIVAOC,
           N.VRIVA19,
           N.VRIVA20,
           N.VRIMPINT21,
           N.VRPIBMIS,
           N.VRPIIBBTUC,
           N.CDFACTPORTAL,
           N.NRFACTPORTAL
          FROM USR_FACTURA_PORTAL N, FORNECEDOR F
         WHERE N.CDFORNECED = F.CDFORNECED
           AND N.DTIMPORTACAO IS NULL
           AND N.HRIMPORTACAO IS NULL
           AND N.DTGRAVACAO IS NOT NULL
           AND N.HRGRAVACAO IS NOT NULL
           AND N.IDORIGREGISTRO = 'P'
           AND EXISTS (SELECT 1
                        FROM FILGRUPFILI
                       WHERE FILGRUPFILI.CDGRUPFILI = '9999999999'
                         AND FILGRUPFILI.CDFILIAL = N.CDFILIAL)
        ORDER BY N.NRSEQUENCIAL)
      LOOP
        V_COUNTERRO := 0;
        V_DSERROFACTURA := NULL;
        BEGIN
           SELECT DECODE(PG.IDUTILDTPROC, 'S', NVL(PF.DTPROCESSA, SYSDATE), SYSDATE) AS DTPROCESSA
             INTO V_DTPROCESSA
           FROM PARAMFILIAL PF, PARAMGERAL PG
           WHERE PF.CDFILIAL = C_NOTAFISCAL.CDFILIAL;
        EXCEPTION
           WHEN NO_DATA_FOUND THEN BEGIN
              V_DTPROCESSA := NULL;
           END;
        END;

        BEGIN
           SELECT NVL(IDATUESTTPOP, 'S')
             INTO V_IDATUESTTPOP
             FROM TIPOOPERAC
            WHERE CDTIPOOPER = '01'
              AND IDENTRSAIDOP = 'E'
              AND IDORIGDESTOP = 'F';
        EXCEPTION
              WHEN NO_DATA_FOUND THEN BEGIN
                 V_IDATUESTTPOP := 'S';
              END;
        END;
        NOVO_CODIGO_NT('LANCNF/FILIAL'||C_NOTAFISCAL.CDFILIAL, V_INPRXNOTAFISCAL);
        V_INPRXNOTAFISCAL := SUBSTR(V_INPRXNOTAFISCAL,11,10);
        BEGIN
           SELECT MAX(F.CDEMPRESA), NVL(MAX(P.IDCTRLESTQ), 'S')
             INTO V_CDEMPRESA, V_IDCTRLESTQ
             FROM FILIAL F, PARAMFILIAL P
            WHERE F.CDFILIAL = C_NOTAFISCAL.CDFILIAL
              AND F.CDFILIAL = P.CDFILIAL;
        EXCEPTION
           WHEN NO_DATA_FOUND THEN BEGIN
              V_CDEMPRESA  := NULL;
              V_IDCTRLESTQ := 'S';
           END;
        END;
        IF ((V_IDCTRLESTQ = 'S') AND (V_IDATUESTTPOP = 'S')) THEN
           NOVO_CODIGO_NT('LANCTOEST'||C_NOTAFISCAL.CDFILIAL, V_INPRXLANCTOESTOQ);
           V_INPRXLANCTOESTOQ := SUBSTR(V_INPRXLANCTOESTOQ, 11, 10);
        END IF;
        V_DTENTRSAID := NULL;
        SELECT MAX(DTENTRSAID)
          INTO V_DTENTRSAID
          FROM NOTAFISCAL N
         WHERE N.CDEMPRESA = V_CDEMPRESA
           AND N.CDSERIEENTR = C_NOTAFISCAL.CDSERIE
           AND N.CDFILIRECE = C_NOTAFISCAL.CDFILIAL
           AND N.CDFORNECED = C_NOTAFISCAL.CDFORNECED
           AND LPAD(N.NRNOTAFISC,20,'0') = LPAD(C_NOTAFISCAL.NRNOTAFISC,20,'0')
           AND N.CDFILIAL||N.NRLANCTONF <> C_NOTAFISCAL.CDFILIAL||V_INPRXLANCTOESTOQ
           AND N.IDENTRSAIDOP = 'E';
        V_IDERRONFDUPLICA := 'N';
        IF V_DTENTRSAID IS NOT NULL THEN
           SELECT MAX(IDCONSORCFIN), MAX(NRDIASBLOQNF)
             INTO V_IDCONSORCFIN, V_NRDIASBLOQNF
             FROM PARAMGERAL
            WHERE CDPARGERAL = '0001';
           IF (V_NRDIASBLOQNF IS NOT NULL) AND (V_NRDIASBLOQNF <> 0) THEN
              IF NOT ((V_DTENTRSAID > (C_NOTAFISCAL.DTENTRSAID + V_NRDIASBLOQNF)) OR
                      (V_DTENTRSAID < (C_NOTAFISCAL.DTENTRSAID - V_NRDIASBLOQNF))) THEN
                 V_COUNTERRO       := V_COUNTERRO + 1;
                 V_IDERRONFDUPLICA := 'S';
              END IF;
           ELSE
              V_COUNTERRO       := V_COUNTERRO + 1;
              V_IDERRONFDUPLICA := 'S';
           END IF;
        END IF;
        IF V_IDERRONFDUPLICA = 'S' THEN
           IF V_DSERROFACTURA IS NULL THEN
              V_DSERROFACTURA := 'Documento ya registrado.';
           ELSE
              V_DSERROFACTURA := V_DSERROFACTURA||' / '||'Documento ya registrado.';
           END IF;
        END IF;
        IF V_DSERROFACTURA IS NULL THEN
           SELECT COUNT(1)
            INTO V_COUNTSERIE
            FROM SERIEENTR
           WHERE CDSERIEENTR = C_NOTAFISCAL.CDSERIE;
           IF NOT(V_COUNTSERIE > 0) THEN
             INSERT INTO SERIEENTR(CDSERIEENTR, DSSERIEENTR)
             VALUES(C_NOTAFISCAL.CDSERIE, C_NOTAFISCAL.CDSERIE);
           END IF;
           GERA_NOTAFISCAL_CORPO_ENTRADA(C_NOTAFISCAL.CDFILIAL,
                                        C_NOTAFISCAL.CDFILIAL,
                                        V_CDEMPRESA,
                                        '01',
                                        C_NOTAFISCAL.CDSERIE,
                                        C_NOTAFISCAL.CDFORNECED,
                                        C_NOTAFISCAL.DTENTRSAID,
                                        'DFE',
                                        C_NOTAFISCAL.VRNOTAFISC,
                                        V_PRXLANCTONF,
                                        V_PRXLANCESTQ,
                                        V_IDATUESTTPOP,
                                        '',
                                        V_INPRXNOTAFISCAL,
                                        '',
                                        '',
                                        '',
                                        '',
                                        '',
                                        '',
                                        '',
                                        '',
                                        '',
                                        NULL,
                                        NULL,
                                        V_INPRXLANCTOESTOQ,
                                        '',
                                        NULL,
                                        C_NOTAFISCAL.NRNOTAFISC,
                                        C_NOTAFISCAL.DTEMISSAO);
           FOR C_ITEMPRODUTO IN
            (SELECT
                P.CDARVPROD,
                P.NMPRODUTO,
                I.QTITEMPROD,
                I.VRUNITITEM,
                NVL(I.VRDESCITEM, 0) VRDESCITEM,
                P.CDPRODUTO,
                ' ' AS IDSTATUS,
                I.CDFILIAL,
                I.NRSEQUENCIAL NRLANCTONF,
                VRIVAMP,
                VRIMPINT02,
                VRPIBBA,
                VRPERCIVA,
                VRABASTOS,
                VRPIBCP,
                VRPIBCBA,
                VRPIBSFE,
                VRPIBMZA,
                VRPIBSJ,
                VRPIBCAT,
                VRPIBTUC,
                VRPIBCTE,
                VRPIBSAL,
                VRPIBSL,
                VRPIBTF,
                VRIVAOC,
                VRIVA19,
                VRIVA20,
                VRIMPINT21,
                VRPIBMIS,
                VRPIIBBTUC
             FROM USR_ITEM_FACTURA I, PRODUTO P
             WHERE I.CDFILIAL   = C_NOTAFISCAL.CDFILIAL
               AND I.NRSEQUENCIAL = C_NOTAFISCAL.NRSEQUENCIAL
               AND I.CDPRODUTO = P.CDARVPROD
             ORDER BY P.CDARVPROD)
           LOOP
             INSERT INTO NFRELACAF
                (CDFILIAL,NRLANCTONF,CDFILDEST,CDFILLANC,NRAUTOFORN,CDMARCA,CDPRODUTO,DTPROGENTAF,QTNFRELACAF,VRNFRELACAF)
             SELECT
                C_NOTAFISCAL.CDFILIAL,
                V_INPRXNOTAFISCAL,
                ITEMAUTF.CDFILDEST,
                ITEMAUTF.CDFILLANC,
                ITEMAUTF.NRAUTOFORN,
                ITEMAUTF.CDMARCA,
                ITEMAUTF.CDPRODUTO,
                ITEMAUTF.DTPROGENTAF,
                C_ITEMPRODUTO.QTITEMPROD,
                C_ITEMPRODUTO.VRUNITITEM
              FROM ITEMAUTF, USR_AF_FACTURA
             WHERE USR_AF_FACTURA.NRSEQUENCIAL = C_NOTAFISCAL.NRSEQUENCIAL
               AND USR_AF_FACTURA.CDFILDEST    = C_NOTAFISCAL.CDFILIAL
               AND USR_AF_FACTURA.CDFILDEST    = ITEMAUTF.CDFILDEST
               AND USR_AF_FACTURA.CDFILLANC    = ITEMAUTF.CDFILLANC
               AND USR_AF_FACTURA.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN
               AND ITEMAUTF.CDPRODUTO          = C_ITEMPRODUTO.CDPRODUTO
               AND NOT EXISTS (SELECT 1
                                 FROM NFRELACAF N
                                WHERE N.CDFILIAL = C_NOTAFISCAL.CDFILIAL
                                  AND N.NRLANCTONF = V_INPRXNOTAFISCAL
                                  AND N.CDFILDEST = ITEMAUTF.CDFILDEST
                                  AND N.CDFILLANC = ITEMAUTF.CDFILLANC
                                  AND N.NRAUTOFORN = ITEMAUTF.NRAUTOFORN
                                  AND N.CDPRODUTO = ITEMAUTF.CDPRODUTO
                                  AND N.CDMARCA = ITEMAUTF.CDMARCA
                                  AND N.DTPROGENTAF = ITEMAUTF.DTPROGENTAF);

             GERA_NOTAFISCAL_PRODUTO(C_NOTAFISCAL.CDFILIAL,
                                     V_INPRXNOTAFISCAL,
                                     C_ITEMPRODUTO.CDPRODUTO,
                                     C_ITEMPRODUTO.CDARVPROD,
                                     C_ITEMPRODUTO.NMPRODUTO,
                                     C_ITEMPRODUTO.QTITEMPROD,
                                     C_ITEMPRODUTO.VRUNITITEM);

             SELECT MAX(NRSEQITPROD)
               INTO V_NRSEQITPROD
               FROM ITEMPRODUTO
              WHERE ITEMPRODUTO.CDFILIAL = C_NOTAFISCAL.CDFILIAL
                AND ITEMPRODUTO.NRLANCTONF = V_INPRXNOTAFISCAL
                AND ITEMPRODUTO.CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO;

             FOR C_IMPOSTO IN
                (SELECT U.CDIMPOSTO, U.VRALIQUOTA, U.VRIMPOSTO
                   FROM USR_IMPOSTO_ITEM_FACTURA U, IMPOSTO I
                  WHERE U.CDIMPOSTO  = I.CDIMPOSTO
                    AND NRSEQUENCIAL = C_NOTAFISCAL.NRSEQUENCIAL
                    AND CDFILIAL     = C_NOTAFISCAL.CDFILIAL
                    AND NRSEQITPROD  = V_NRSEQITPROD)
			   /*(SELECT CDIMPOSTO
                  FROM IMPOSTO
                 ORDER BY CDIMPOSTO)*/
             LOOP
/*               IF ((C_IMPOSTO.CDIMPOSTO = '01') AND (C_ITEMPRODUTO.VRIVAMP     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '02') AND (C_ITEMPRODUTO.VRIMPINT02  > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '03') AND (C_ITEMPRODUTO.VRPIBBA     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '04') AND (C_ITEMPRODUTO.VRPERCIVA   > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '05') AND (C_ITEMPRODUTO.VRABASTOS   > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '07') AND (C_ITEMPRODUTO.VRPIBCP     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '08') AND (C_ITEMPRODUTO.VRPIBCBA    > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '09') AND (C_ITEMPRODUTO.VRPIBSFE    > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '10') AND (C_ITEMPRODUTO.VRPIBMZA    > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '11') AND (C_ITEMPRODUTO.VRPIBSJ     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '12') AND (C_ITEMPRODUTO.VRPIBCAT    > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '13') AND (C_ITEMPRODUTO.VRPIBTUC    > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '14') AND (C_ITEMPRODUTO.VRPIBCTE    > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '15') AND (C_ITEMPRODUTO.VRPIBSAL    > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '16') AND (C_ITEMPRODUTO.VRPIBSL     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '17') AND (C_ITEMPRODUTO.VRPIBTF     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '18') AND (C_ITEMPRODUTO.VRIVAOC     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '19') AND (C_ITEMPRODUTO.VRIVA19     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '20') AND (C_ITEMPRODUTO.VRIVA20     > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '21') AND (C_ITEMPRODUTO.VRIMPINT21  > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '22') AND (C_ITEMPRODUTO.VRPIBMIS    > 0))   OR
                  ((C_IMPOSTO.CDIMPOSTO = '24') AND (C_ITEMPRODUTO.VRPIIBBTUC  > 0))   THEN

                  SELECT DECODE(C_IMPOSTO.CDIMPOSTO,
                                '01', C_ITEMPRODUTO.VRIVAMP,
                                '02', C_ITEMPRODUTO.VRIMPINT02,
                                '03', C_ITEMPRODUTO.VRPIBBA,
                                '04', C_ITEMPRODUTO.VRPERCIVA,
                                '05', C_ITEMPRODUTO.VRABASTOS,
                                '07', C_ITEMPRODUTO.VRPIBCP,
                                '08', C_ITEMPRODUTO.VRPIBCBA,
                                '09', C_ITEMPRODUTO.VRPIBSFE,
                                '10', C_ITEMPRODUTO.VRPIBMZA,
                                '11', C_ITEMPRODUTO.VRPIBSJ,
                                '12', C_ITEMPRODUTO.VRPIBCAT,
                                '13', C_ITEMPRODUTO.VRPIBTUC,
                                '14', C_ITEMPRODUTO.VRPIBCTE,
                                '15', C_ITEMPRODUTO.VRPIBSAL,
                                '16', C_ITEMPRODUTO.VRPIBSL,
                                '17', C_ITEMPRODUTO.VRPIBTF,
                                '18', C_ITEMPRODUTO.VRIVAOC,
                                '19', C_ITEMPRODUTO.VRIVA19,
                                '20', C_ITEMPRODUTO.VRIVA20,
                                '21', C_ITEMPRODUTO.VRIMPINT21,
                                '22', C_ITEMPRODUTO.VRPIBMIS,
                                '24', C_ITEMPRODUTO.VRPIIBBTUC)
                     INTO V_IMPOSINFO
                     FROM DUAL;
*/
                  V_BASECALCIT := C_ITEMPRODUTO.QTITEMPROD * C_ITEMPRODUTO.VRUNITITEM;
                  V_VRCONTIMPOIT := ROUND(V_BASECALCIT, 2);
/*                  V_ALIQUTMP   := ROUND((V_IMPOSINFO * 100)/ V_BASECALCIT,2);
                  FOR C_ALIQUOTA IN
                     (SELECT DISTINCT VRALIQUOTA, ABS(VRALIQUOTA - V_ALIQUTMP)
                        FROM ALIQUOTA
                       ORDER BY ABS(VRALIQUOTA - V_ALIQUTMP))
                  LOOP
                     V_ALIQUTMP := C_ALIQUOTA.VRALIQUOTA;
                     EXIT;
                  END LOOP;
*/
                  INSERT INTO TRABITPROIMPOS
                    (CDFILIMPOIT,
                     NRLANCIMPOIT,
                     NRSEQIMPOIT,
                     CDIMPOSTOIT,
                     VRCONTIMPOIT,
                     VRREDBCIMPOIT,
                     VRBCALCIMPOIT,
                     VRALIQIMPOIT,
                     VRPDEDIMPOIT,
                     VRIMPOSIT,
                     NRSEQITPRO,
                     IDVALORINFO)
                  VALUES
                    (C_ITEMPRODUTO.CDFILIAL,
                     V_INPRXNOTAFISCAL,
                     V_NRSEQITPROD,
                     C_IMPOSTO.CDIMPOSTO,
                     V_VRCONTIMPOIT,
                     0,
                     V_BASECALCIT,
                     C_IMPOSTO.VRALIQUOTA, --V_ALIQUTMP,
                     0,
                     C_IMPOSTO.VRIMPOSTO, --VRIMPOSTO,
                     '1',
                     'S');
--               END IF;
             END LOOP;

             SELECT MAX(ITEMAUTF.CDMARCA)
                INTO V_CDMARCA
                FROM USR_AF_FACTURA, ITEMAUTF
               WHERE USR_AF_FACTURA.NRSEQUENCIAL = C_NOTAFISCAL.NRSEQUENCIAL
               AND USR_AF_FACTURA.CDFILDEST = C_NOTAFISCAL.CDFILIAL
               AND USR_AF_FACTURA.CDFILDEST = ITEMAUTF.CDFILDEST
               AND USR_AF_FACTURA.CDFILLANC = ITEMAUTF.CDFILLANC
               AND USR_AF_FACTURA.NRAUTOFORN = ITEMAUTF.NRAUTOFORN
               AND ITEMAUTF.CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO;
             V_IDERRONFRELACAF := 'N';
             NF_BAIXA_AF(C_NOTAFISCAL.CDFILIAL,
                         V_INPRXNOTAFISCAL,
                         V_NRSEQITPROD,
                         'I',
                         C_ITEMPRODUTO.CDARVPROD,
                         C_ITEMPRODUTO.CDARVPROD,
                         C_ITEMPRODUTO.CDPRODUTO,
                         C_ITEMPRODUTO.CDPRODUTO,
                         V_CDMARCA,
                         V_CDMARCA,
                         C_ITEMPRODUTO.QTITEMPROD,
                         C_ITEMPRODUTO.QTITEMPROD,
                         V_IDERRONFRELACAF);
             IF V_IDERRONFRELACAF = 'S' THEN
                V_COUNTERRO := V_COUNTERRO + 1;
                IF V_DSERROFACTURA IS NULL THEN
                   V_DSERROFACTURA := 'Existen productos en la factura que no son originados de AS.';
                ELSE
                   V_DSERROFACTURA := V_DSERROFACTURA||' / '||'Existen productos en la factura que no son originados de AS.';
                END IF;
             END IF;
           END LOOP;
           
           FOR C_IMPOSTO_NF IN
              (SELECT U.CDIMPOSTO, U.VRALIQUOTA, U.VRIMPOSTO
                 FROM USR_IMPOSTO_FACTURA U, IMPOSTO I
                WHERE U.CDIMPOSTO = I.CDIMPOSTO
                  AND NRSEQUENCIAL = C_NOTAFISCAL.NRSEQUENCIAL
                  AND CDFILIAL     = C_NOTAFISCAL.CDFILIAL)


             /*(SELECT CDIMPOSTO
                FROM IMPOSTO
               ORDER BY CDIMPOSTO)*/
           LOOP
/*             IF ((C_IMPOSTO.CDIMPOSTO = '01') AND (C_NOTAFISCAL.VRIVAMP     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '02') AND (C_NOTAFISCAL.VRIMPINT02  > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '03') AND (C_NOTAFISCAL.VRPIBBA     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '04') AND (C_NOTAFISCAL.VRPERCIVA   > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '05') AND (C_NOTAFISCAL.VRABASTOS   > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '07') AND (C_NOTAFISCAL.VRPIBCP     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '08') AND (C_NOTAFISCAL.VRPIBCBA    > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '09') AND (C_NOTAFISCAL.VRPIBSFE    > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '10') AND (C_NOTAFISCAL.VRPIBMZA    > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '11') AND (C_NOTAFISCAL.VRPIBSJ     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '12') AND (C_NOTAFISCAL.VRPIBCAT    > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '13') AND (C_NOTAFISCAL.VRPIBTUC    > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '14') AND (C_NOTAFISCAL.VRPIBCTE    > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '15') AND (C_NOTAFISCAL.VRPIBSAL    > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '16') AND (C_NOTAFISCAL.VRPIBSL     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '17') AND (C_NOTAFISCAL.VRPIBTF     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '18') AND (C_NOTAFISCAL.VRIVAOC     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '19') AND (C_NOTAFISCAL.VRIVA19     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '20') AND (C_NOTAFISCAL.VRIVA20     > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '21') AND (C_NOTAFISCAL.VRIMPINT21  > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '22') AND (C_NOTAFISCAL.VRPIBMIS    > 0))   OR
                ((C_IMPOSTO.CDIMPOSTO = '24') AND (C_NOTAFISCAL.VRPIIBBTUC  > 0))   THEN*/
                INSERT INTO TRABIMPOSNFTOT
                  (CDFILIMPTOT,
                   NRLANCIMPTOT,
                   CDIMPOSTOT,
                   IDERROSTOT,
                   IDAVISOSTOT,
                   VRBCALIMPTOT,
                   VRIMPOSTOT)
                VALUES
                  (C_NOTAFISCAL.CDFILIAL,
                   V_INPRXNOTAFISCAL,
                   C_IMPOSTO_NF.CDIMPOSTO,
                   '00000',
                   '00000',
                   C_NOTAFISCAL.VRNOTAFISC,
                   C_IMPOSTO_NF.VRIMPOSTO   
                   /*DECODE(C_IMPOSTO.CDIMPOSTO,
                          '01', C_NOTAFISCAL.VRIVAMP,
                          '02', C_NOTAFISCAL.VRIMPINT02,
                          '03', C_NOTAFISCAL.VRPIBBA,
                          '04', C_NOTAFISCAL.VRPERCIVA,
                          '05', C_NOTAFISCAL.VRABASTOS,
                          '07', C_NOTAFISCAL.VRPIBCP,
                          '08', C_NOTAFISCAL.VRPIBCBA,
                          '09', C_NOTAFISCAL.VRPIBSFE,
                          '10', C_NOTAFISCAL.VRPIBMZA,
                          '11', C_NOTAFISCAL.VRPIBSJ,
                          '12', C_NOTAFISCAL.VRPIBCAT,
                          '13', C_NOTAFISCAL.VRPIBTUC,
                          '14', C_NOTAFISCAL.VRPIBCTE,
                          '15', C_NOTAFISCAL.VRPIBSAL,
                          '16', C_NOTAFISCAL.VRPIBSL,
                          '17', C_NOTAFISCAL.VRPIBTF,
                          '18', C_NOTAFISCAL.VRIVAOC,
                          '19', C_NOTAFISCAL.VRIVA19,
                          '20', C_NOTAFISCAL.VRIVA20,
                          '21', C_NOTAFISCAL.VRIMPINT21,
                          '22', C_NOTAFISCAL.VRPIBMIS,
                          '24', C_NOTAFISCAL.VRPIIBBTUC)
						  */
                    );
--             END IF;
           END LOOP;
           FOR C_ENCARGO IN
             (SELECT CDENCARGO, VRITEMENCA
                FROM USR_ENCARGO_FACTURA
               WHERE CDFILIAL = C_NOTAFISCAL.CDFILIAL
                 AND NRSEQUENCIAL = V_INPRXNOTAFISCAL
                 AND VRITEMENCA <> 0)
           LOOP
              GERA_NOTAFISCAL_ENCARGO(C_NOTAFISCAL.CDFILIAL,
                                      V_INPRXNOTAFISCAL,
                                      C_ENCARGO.CDENCARGO,
                                      C_ENCARGO.VRITEMENCA);
           END LOOP;

           CRIA_VENCIMENTO(C_NOTAFISCAL.CDFILIAL,
                           V_INPRXNOTAFISCAL,
                           'E',
                           C_NOTAFISCAL.VRNOTAFISC,
                           C_NOTAFISCAL.DTEMISSAO,
                           C_NOTAFISCAL.DTENTRSAID,
                           C_NOTAFISCAL.CDFORNECED,
                           C_NOTAFISCAL.CDFILIAL,
                           'F',
                           NULL,
                           NULL,
                           NULL,
                           NULL,
                           NULL);
           /*INSERE A CONTA A PAGAR DE ACORDO COM OS VENCIMENTOS GERADOS*/
           /*TRAB_VENCIMENTO : TABELA TEMPORARIA PREENCHIDA PELA CRIA_VENCIMENTO*/
           FOR C_ITEMTRAB IN (SELECT DTVENCIMENTO, VRVENCIMENTO, QTDIASVENC, NRSEQVENC
                               FROM TRAB_VENCIMENTO
                              WHERE CDFILIALVENC = C_NOTAFISCAL.CDFILIAL
                                AND NRLANCTONFVENC = V_INPRXNOTAFISCAL
                              ORDER BY NRSEQVENC) LOOP
              /*INSERE OS VENCIMENTOS GERADOS NA TABELA DE CONTAS A PAGAR*/
              INSERT INTO CONTAPAGAR
                 (CDFILIAL, NRLANCTONF, CDMOTIPROR, CDMOTIPARC, CDTPCTPAGAR, NRSEQVENPAG,
                 NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG, DTATUAVENPAG, VRATUAPAG,
                 IDSTATPAG, DSCONTAPAG, CDFILIBPAG, NRLANBOLPAG)
              VALUES
                 (C_NOTAFISCAL.CDFILIAL, V_INPRXNOTAFISCAL, NULL, NULL, NULL, SUBSTR(C_ITEMTRAB.NRSEQVENC, LENGTH(C_ITEMTRAB.NRSEQVENC) -1, 2),  '00', C_ITEMTRAB.QTDIASVENC,
                 C_ITEMTRAB.DTVENCIMENTO, C_ITEMTRAB.VRVENCIMENTO, C_ITEMTRAB.DTVENCIMENTO , C_ITEMTRAB.VRVENCIMENTO, 'A', NULL, NULL, NULL);
           END LOOP;
           GERA_FECHAMENTO_NFENTRADA(C_NOTAFISCAL.CDFILIAL, V_INPRXNOTAFISCAL, V_DTPROCESSA, V_INPRXLANCTOESTOQ);
           UPDATE NOTAFISCAL
             SET CDMODDOCFISC = '99', USR_CDFACTPORTAL = C_NOTAFISCAL.CDFACTPORTAL, USR_NRFACTPORTAL = C_NOTAFISCAL.NRFACTPORTAL, IDBLOQUEADO = 'S'
           WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
             AND NRLANCTONF = V_INPRXNOTAFISCAL;
        END IF;
        IF V_COUNTERRO > 0 THEN
           ROLLBACK;
        ELSE
           COMMIT;
        END IF;
        UPDATE USR_FACTURA_PORTAL
           SET DTIMPORTACAO  = TO_DATE(SYSDATE),
               HRIMPORTACAO  = TO_CHAR(SYSDATE, 'HH24MI'),
               QTERROFACTURA = V_COUNTERRO,
               DSERROFACTURA = V_DSERROFACTURA,
               CHAVETEKNISA  = C_NOTAFISCAL.CDFILIAL||V_INPRXNOTAFISCAL
         WHERE NRSEQUENCIAL  = C_NOTAFISCAL.NRSEQUENCIAL
           AND CDFILIAL      = C_NOTAFISCAL.CDFILIAL;
        COMMIT;
      END LOOP;
      V_RETURN := USR_FUNC_BLOQUEIO('USR_FACTURA_PORTAL%USR_ITEM_FACTURA%USR_ENCARGO_FACTURA%USR_AF_FACTURA', 'D');
   END IF;
EXCEPTION
  WHEN OTHERS THEN BEGIN
     IF V_RETURN = 'S' THEN
        ROLLBACK;
        V_ERROR:= SQLERRM(SQLCODE);
        V_RETURN := USR_FUNC_BLOQUEIO('USR_FACTURA_PORTAL%USR_ITEM_FACTURA%USR_ENCARGO_FACTURA%USR_AF_FACTURA', 'D', V_ERROR);
     END IF;
  END;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_IMPORTA_NF','5.70.XXX'); END;
/