import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";

export class Card extends ChartViewAbstract implements ChartViewInterface {
    public hasMultipleFacts: Boolean = false;

    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].children[0].text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        widget[0].color = dashboard.color;
        return widget;
    }
    public getCharts(charts: any) {
        if (this.getZmartCharts()) {
            this.getZmartCharts().setCardFormatterFunctions(charts);
        }
        return charts;
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
            charts[0].events = {
                "click": this.getZmartCharts().drillCard.bind(this.getZmartCharts())
            };
        return charts;
    }

    public getWidgetDashboard(widget: any, dashboard: any) {
        if (dashboard.w && widget[0] && widget[0].name && widget[0].name !== "notFound") {
            widget[0].children[1].textResize.fontSize = (dashboard.w * 10);
        }
        return widget;
    }

    public getSaveViewParams(formExtra: any, values: any, cleanValues: any) {
        cleanValues.cardTitle = cleanValues.cardTitle47;
        return cleanValues;
    }

    public getEditData(viewData: any) {
        viewData.cardTitle47 = viewData.cardTitle;
        return viewData;
    }
}
