import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";
import { ChartViewService } from "../ChartViewService";

export class PiePivot extends ChartViewAbstract implements ChartViewInterface {
    public legendPositionDropdownIsVisible: Boolean = true;

    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    public getCharts(charts: any) {
        if (charts[0].mask !== null) {
            charts[0].options.series[0].tooltip.valueFormatter = ChartViewService.getMaskFunction(charts[0].mask);
        }
        if (charts[0].options.series[0].label.formatter === null) {
            charts[0].options.series[0].label.formatter = this.getMaskRotuloPie(charts[0].mask);
        }
        return charts;
    }

    public getMaskPie(mask: string, params: any) {
        return ChartViewService.getMaskFunction(mask)(params.data.value);
    }

    public getMaskRotuloPie(mask: string) {
        return this.getMaskPie.bind(this, mask);
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;

        charts[0].events = {
            "chartClick": this.getZmartCharts().drillEChartsBar.bind(this.getZmartCharts(), charts[0].widget),
        };

        return charts;
    }
}
