export class Metric {

    public static metricSuffixes = ['', 'K', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y'];

    public static getFunction() :Function {
        return this.format.bind(this);
    }

    public static format(value: any, params: any) {
        let valueToReturn = "";
        params = params || {};

        if (isNaN(value)) {
            if (typeof (value) === "string") {
                value = parseFloat(value);
            }
        }
        valueToReturn = this.dirtyValue(this.metricEncode(value));

        return valueToReturn;
    }

    public static metricEncode(value: any) {
        let i = 0;
        while (Math.abs(value) >= 1000) {
            value /= 1000;
            i += 1;
        }
        value = this.roundDecimal(value, 2);
        return value + this.metricSuffixes[i];
    }

    public static dirtyValue(value: any) {
        value = String(value);
        value = value.replace('.', ",");
        return value;
    }

    public static roundDecimal(value: any, decimals: any) {
        const pow = 10 ** decimals;
        return Math.round(value * pow) / pow;
    }
}
